#ifndef TILDA_H
#define TILDA_H

#include <assert.h>
#include <dbus/dbus-glib-bindings.h>

/* Optional debugging macros */
#ifdef DEBUG
	#define debug_enter() do { g_print ("debug enter: %s\n", __func__); } while (0)
	#define debug_printf(args...) do { g_print ("debug: " args); } while (0)
	#define debug_assert(args...) do { g_assert (args); } while (0)
#else
	#define debug_enter()         do { /* nothing */ } while (0)
	#define debug_printf(args...) do { /* nothing */ } while (0)
	#define debug_assert(args...) do { /* nothing */ } while (0)
#endif

/* Optional gettext translation macros */
#ifdef ENABLE_NLS
	#include <glib/gi18n.h>
#else
	#define _(X) X
	#define N_(X) X
#endif

// FIXME: remove when the project is autoconfed
#define TILDA_VERSION "0.10.0pre"

/* Project-global variables */
extern DBusGConnection *dbus_connection;

/* API */
void tilda_del_window (gint number);

#endif /* TILDA_H */

/* vim: set ts=4 sts=4 sw=4 noet tw=112: */

